/*
Sauvergarder un sketch depuis un bouton cliquable
----------------------

p5js propose directement une fonction d'export : save()

comme on ne veut pas enregistrer 60 images par secondes(!)
un bouton semble une bonne solution

Pb : rendre un bouton cliquable c'est :
- afficher l'image d'un bouton
- détecter le clic sur le sketch
- vérifier si on était au-dessus du bouton ou pas 
(ce qui n'est pas prévu apr défaut dans p5js)

-> à intégrer dans tous vos sketch !
------------------------------------
*/
var png;

var btnPos = {x: 30, y:90}; // position future du bouton
var btnDim = {l:45, h:45}; // taille d'affichage de l'image (qui fait 64x64 à l'origine)

function setup(){ 
	createCanvas(windowWidth, windowHeight);	
	noStroke();

	// on charge l'image, mais elle n'est pas encore affichée
	png = loadImage('img/save.png');

	// et si vous vouliez le placer en bas à droite...
	// par rapport au coin inférieur-droit, qui dépend de la taille de la fenêtre
	// btnPos.x = windowWidth-btnPos.x-btnDim.l;
	// btnPos.y = windowHeight-btnPos.y-btnDim.h;
}

function draw(){

	// il faut bien afficher quelque chose à capturer !
	fill(random(0, 255), random(0, 255), random(0, 255));
	ellipse(random(0, width), random(0, height), 10, 10);

	// et le bouton
	image(png, btnPos.x, btnPos.y, btnDim.l, btnDim.h);

	// afficher le mode d'emploi !
	fill(255); // rectangle blanc sous le texte...
	rect(15, 8, 230, 34)
	fill(0);
	text("// Bouton de sauvegarde du sketch", 30, 30);
}

function mouseReleased(){
	// p5js exécute automatiquement cette fonction 
	// quand on relache un bouton de la souris, on qu'on retire le doigt de l'écran

	// pb : on n'était pas forcément au-dessus du bouton !
	// on va comparer la position de la souris avec celle du bouton :
	if(mouseX>=btnPos.x && mouseX<=btnPos.x+btnDim.l && mouseY>=btnPos.y && mouseY<=btnPos.y+btnDim.h){
		// c'était sur l'image !

		// enregistrement immédiat !
		save();
		// et c'est tout !
	}
}